#!/usr/bin/perl -w

use strict;
use bigint;

$#ARGV == 1 or die "usage: perl_mannwhitney_ref.pl <size of both samples> <U>";

my ($size, $Ugiven)= @ARGV;

sub choose
{
  my ($n, $k)= @_;

  return 1 if $k == 0;
  return 0 if $n == 0;
  return choose($n-1, $k-1) * $n / $k;
}

sub nlimitchoices
{
  my ($sum, $n, $m, $u)= @_;

  return if $u < 0;
  if( $m == 0 ) {
    ++$$sum;
    return;
  }
  for (0..$n-$m) { nlimitchoices($sum, $n-$_-1, $m-1, $u-$_*$m); }
}

print choose(2*$size, $size), "\n";

my $sum;
nlimitchoices(\$sum, 2*$size, $size, $Ugiven);
print $sum, "\n";


