
// import java.util.Stack;

class java_mannwhitney {

  public static void main(String argv[]) {
    long size= Long.parseLong(argv[0]);
    long u= Long.parseLong(argv[1]);
    System.out.print(choose(size*2, size));
    System.out.println();
    System.out.print(nlimitchoices_ia(size*2, size, u));
    System.out.println();
  }

  public static long choose(long n, long m) {
    if( m == 0 ) { return 1; }
    if( n <= 0 ) { return 0; }
    return choose(n-1, m-1) * n / m;
  }

  public static long nlimitchoices(long n, long m, long u) {
    long total;
    if( u < 0 ) { return 0; }
    if( m == 0 ) { return 1; }
    total= 0;
    for( int d= 0; d<= n-m; ++d ) {
      total += nlimitchoices(n-d-1, m-1, u-m*d);
    }
    return total;
  }

// not used:
//  public static long nlimitchoices_i(long n, long m, long u) {
//    if( n < m || u < 0 ) {
//      return 0;
//    }
//    long num= 0;
//    Stack st= new Stack();
//    st.push(0);
//    while( !st.empty() ) {
//      while( m > 1 ) {
//	st.push(0);
//	--n;
//	--m;
//      }
//      ++num;
//      while( !st.empty() ) {
//	Integer topd= 0; // st.pop();
//	++topd;
//	--n;
//	u -= m;
//	if( n >= m && u >= 0 ) {
//	  st.push(topd);
//	  break;
//	}
//	n += topd+1;
//	u += m*topd;
//	++m;
//      }
//    }
//    return num;
//  }

  public static long nlimitchoices_ia(long n, long m, long u) {
    if( n < m || u < 0 ) {
      return 0;
    }
    long num= 0;
    int[] st= new int[(int)m];
    int dind= 0;
    st[dind]= 0;
    while( dind >= 0 ) {
      while( m > 1 ) {
        ++dind;
        st[dind]= 0;
        --n;
        --m;
      }
      ++num;
      while( dind >= 0 ) {
        ++st[dind];
        --n;
        u -= m;
        if( n >= m && u >= 0 ) {
          break;
        }
        n += st[dind]+1;
        u += m*st[dind];
        ++m;
        --dind;
      }
    }
    return num;
  }

}

